/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreVariable.TCoreVariablePath;
import de.ship.db.tables.records.TInputStaticvarsRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputStaticvars extends TableImpl<TInputStaticvarsRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_staticvars</code>
     */
    public static final TInputStaticvars T_INPUT_STATICVARS = new TInputStaticvars();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputStaticvarsRecord> getRecordType() {
        return TInputStaticvarsRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_staticvars.pk_input_staticvars</code>.
     */
    public final TableField<TInputStaticvarsRecord, Integer> PK_INPUT_STATICVARS = createField(DSL.name("pk_input_staticvars"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_input_staticvars.fk_variable</code>.
     */
    public final TableField<TInputStaticvarsRecord, Integer> FK_VARIABLE = createField(DSL.name("fk_variable"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_input_staticvars.lastchange</code>.
     */
    public final TableField<TInputStaticvarsRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    private TInputStaticvars(Name alias, Table<TInputStaticvarsRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputStaticvars(Name alias, Table<TInputStaticvarsRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_staticvars</code> table
     * reference
     */
    public TInputStaticvars(String alias) {
        this(DSL.name(alias), T_INPUT_STATICVARS);
    }

    /**
     * Create an aliased <code>common_dd.t_input_staticvars</code> table
     * reference
     */
    public TInputStaticvars(Name alias) {
        this(alias, T_INPUT_STATICVARS);
    }

    /**
     * Create a <code>common_dd.t_input_staticvars</code> table reference
     */
    public TInputStaticvars() {
        this(DSL.name("t_input_staticvars"), null);
    }

    public <O extends Record> TInputStaticvars(Table<O> path, ForeignKey<O, TInputStaticvarsRecord> childPath, InverseForeignKey<O, TInputStaticvarsRecord> parentPath) {
        super(path, childPath, parentPath, T_INPUT_STATICVARS);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TInputStaticvarsPath extends TInputStaticvars implements Path<TInputStaticvarsRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TInputStaticvarsPath(Table<O> path, ForeignKey<O, TInputStaticvarsRecord> childPath, InverseForeignKey<O, TInputStaticvarsRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TInputStaticvarsPath(Name alias, Table<TInputStaticvarsRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TInputStaticvarsPath as(String alias) {
            return new TInputStaticvarsPath(DSL.name(alias), this);
        }

        @Override
        public TInputStaticvarsPath as(Name alias) {
            return new TInputStaticvarsPath(alias, this);
        }

        @Override
        public TInputStaticvarsPath as(Table<?> alias) {
            return new TInputStaticvarsPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TInputStaticvarsRecord, Integer> getIdentity() {
        return (Identity<TInputStaticvarsRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TInputStaticvarsRecord> getPrimaryKey() {
        return Keys.PK_INPUT_STATICVARS;
    }

    @Override
    public List<UniqueKey<TInputStaticvarsRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_INPUT_STATICVARS);
    }

    @Override
    public List<ForeignKey<TInputStaticvarsRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_INPUT_STATICVARS__FK_INPUTSTATICVARS_VAR);
    }

    private transient TCoreVariablePath _tCoreVariable;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_variable</code>
     * table.
     */
    public TCoreVariablePath tCoreVariable() {
        if (_tCoreVariable == null)
            _tCoreVariable = new TCoreVariablePath(this, Keys.T_INPUT_STATICVARS__FK_INPUTSTATICVARS_VAR, null);

        return _tCoreVariable;
    }

    @Override
    public TInputStaticvars as(String alias) {
        return new TInputStaticvars(DSL.name(alias), this);
    }

    @Override
    public TInputStaticvars as(Name alias) {
        return new TInputStaticvars(alias, this);
    }

    @Override
    public TInputStaticvars as(Table<?> alias) {
        return new TInputStaticvars(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputStaticvars rename(String name) {
        return new TInputStaticvars(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputStaticvars rename(Name name) {
        return new TInputStaticvars(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputStaticvars rename(Table<?> name) {
        return new TInputStaticvars(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputStaticvars where(Condition condition) {
        return new TInputStaticvars(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputStaticvars where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputStaticvars where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputStaticvars where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputStaticvars where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputStaticvars where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputStaticvars where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputStaticvars where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputStaticvars whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputStaticvars whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
